Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 997)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1001)
@@ -1294,9 +1085,8 @@
 !--          Prognostic equation for salinity
              DO  k = nzb_s_inner(j,i)+1, nzt
-                sa_p(k,j,i) = tsc(1) * sa(k,j,i) +                          &
-                              dt_3d * (                                     &
-                               tsc(2) * tend(k,j,i) + tsc(3) * tsa_m(k,j,i) &
-                                      ) -                                   &
-                             tsc(5) * rdf_sc(k) * ( sa(k,j,i) - sa_init(k) )
+                sa_p(k,j,i) = sa(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +     &
+                                                    tsc(3) * tsa_m(k,j,i) )    &
+                                        - tsc(5) * rdf_sc(k) *                 &
+                                          ( sa(k,j,i) - sa_init(k) )
                 IF ( sa_p(k,j,i) < 0.0 )  sa_p(k,j,i) = 0.1 * sa(k,j,i)
              ENDDO
@@ -1332,8 +1122,7 @@
 !--          Tendency-terms for total water content / scalar
              tend(:,j,i) = 0.0
-             IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) &
+             IF ( timestep_scheme(1:5) == 'runge' ) &
              THEN
                 IF ( ws_scheme_sca )  THEN
-          !         CALL local_diss( i, j, q )
                    CALL advec_s_ws( i, j, q, 'q', flux_s_q, & 
                                 diss_s_q, flux_l_q, diss_l_q, i_omp_start, tn )
@@ -1344,12 +1133,5 @@
                 CALL advec_s_up( i, j, q )
              ENDIF
-             IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )&
-             THEN
-                CALL diffusion_s( i, j, ddzu, ddzw, kh_m, q_m, qsws_m, &
-                                  qswst_m, wall_qflux, tend )
-             ELSE
-                CALL diffusion_s( i, j, ddzu, ddzw, kh, q, qsws, qswst, &
-                                  wall_qflux, tend )
-             ENDIF
+             CALL diffusion_s( i, j, q, qsws, qswst, wall_qflux )
        
 !
@@ -1374,9 +1156,8 @@
 !--          Prognostic equation for total water content / scalar
              DO  k = nzb_s_inner(j,i)+1, nzt
-                q_p(k,j,i) = ( 1.0-tsc(1) ) * q_m(k,j,i) + tsc(1)*q(k,j,i) +&
-                             dt_3d * (                                      &
-                                tsc(2) * tend(k,j,i) + tsc(3) * tq_m(k,j,i) &
-                                     ) -                                    &
-                             tsc(5) * rdf_sc(k) * ( q(k,j,i) - q_init(k) )
+                q_p(k,j,i) = q(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * tq_m(k,j,i) )       &
+                                      - tsc(5) * rdf_sc(k) *                   &
+                                        ( q(k,j,i) - q_init(k) )
                 IF ( q_p(k,j,i) < 0.0 )  q_p(k,j,i) = 0.1 * q(k,j,i)
              ENDDO
@@ -1408,10 +1189,9 @@
 !--          Tendency-terms for TKE
              tend(:,j,i) = 0.0
-             IF ( ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  &
+             IF ( timestep_scheme(1:5) == 'runge'  &
                  .AND.  .NOT. use_upstream_for_tke )  THEN
                  IF ( ws_scheme_sca )  THEN
-                 !    CALL local_diss( i, j, e )
-                     CALL advec_s_ws( i, j, e, 'e', flux_s_e, &
-                                diss_s_e, flux_l_e, diss_l_e , i_omp_start, tn )
+                     CALL advec_s_ws( i, j, e, 'e', flux_s_e, diss_s_e, &
+                                      flux_l_e, diss_l_e , i_omp_start, tn )
                  ELSE
                      CALL advec_s_pw( i, j, e )
@@ -1420,31 +1200,12 @@
                 CALL advec_s_up( i, j, e )
              ENDIF
-             IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )&
-             THEN
-                IF ( .NOT. humidity )  THEN
-                   CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e_m, &
-                                     km_m, l_grid, pt_m, pt_reference,   &
-                                     rif_m, tend, zu, zw )
+             IF ( .NOT. humidity )  THEN
+                IF ( ocean )  THEN
+                   CALL diffusion_e( i, j, prho, prho_reference )
                 ELSE
-                   CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e_m, &
-                                     km_m, l_grid, vpt_m, pt_reference,  &
-                                     rif_m, tend, zu, zw )
+                   CALL diffusion_e( i, j, pt, pt_reference )
                 ENDIF
              ELSE
-                IF ( .NOT. humidity )  THEN
-                   IF ( ocean )  THEN
-                      CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e,  &
-                                        km, l_grid, prho, prho_reference,  &
-                                        rif, tend, zu, zw )
-                   ELSE
-                      CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e,  &
-                                        km, l_grid, pt, pt_reference, rif, &
-                                        tend, zu, zw )
-                   ENDIF
-                ELSE
-                   CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e, km, &
-                                     l_grid, vpt, pt_reference, rif, tend, &
-                                     zu, zw )
-                ENDIF
+                CALL diffusion_e( i, j, vpt, pt_reference )
              ENDIF
              CALL production_e( i, j )
@@ -1462,8 +1223,6 @@
 !--          TKE value is reduced by 90%.
              DO  k = nzb_s_inner(j,i)+1, nzt
-                e_p(k,j,i) = ( 1.0-tsc(1) ) * e_m(k,j,i) + tsc(1)*e(k,j,i) +&
-                             dt_3d * (                                      &
-                                tsc(2) * tend(k,j,i) + tsc(3) * te_m(k,j,i) &
-                                     )
+                e_p(k,j,i) = e(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * te_m(k,j,i) )
                 IF ( e_p(k,j,i) < 0.0 )  e_p(k,j,i) = 0.1 * e(k,j,i)
              ENDDO
@@ -1507,5 +1266,5 @@
     CHARACTER (LEN=9) ::  time_to_string
     INTEGER ::  i, j, k
-    REAL    ::  sat, sbt
+    REAL    ::  sbt
 
 !
@@ -1522,15 +1281,6 @@
     CALL cpu_log( log_point(5), 'u-equation', 'start' )
 
-!
-!-- u-tendency terms with communication
-    IF ( momentum_advec == 'ups-scheme' )  THEN
-       tend = 0.0
-       CALL advec_u_ups
-    ENDIF
-
-!
-!-- u-tendency terms with no communication
-    IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-       tend = 0.0
+    tend = 0.0
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_mom )  THEN
           CALL advec_u_ws
@@ -1539,15 +1289,7 @@
        ENDIF
     ELSE
-       IF ( momentum_advec /= 'ups-scheme' )  THEN
-          tend = 0.0
-          CALL advec_u_up
-       ENDIF
+       CALL advec_u_up
     ENDIF
-    IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-       CALL diffusion_u( ddzu, ddzw, km_m, tend, u_m, usws_m, uswst_m, &
-                         v_m, w_m )
-    ELSE
-       CALL diffusion_u( ddzu, ddzw, km, tend, u, usws, uswst, v, w )
-    ENDIF
+    CALL diffusion_u
     CALL coriolis( 1 )
     IF ( sloping_surface  .AND.  .NOT. neutral )  THEN
@@ -1578,9 +1320,7 @@
        DO  j = nys, nyn
           DO  k = nzb_u_inner(j,i)+1, nzt
-             u_p(k,j,i) = ( 1.0-tsc(1) ) * u_m(k,j,i) + tsc(1) * u(k,j,i) +    &
-                          dt_3d * (                                            &
-                                   tsc(2) * tend(k,j,i) + tsc(3) * tu_m(k,j,i) &
-                                  ) -                                          &
-                          tsc(5) * rdf(k) * ( u(k,j,i) - ug(k) )
+             u_p(k,j,i) = u(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
+                                               tsc(3) * tu_m(k,j,i) )          &
+                                   - tsc(5) * rdf(k) * ( u(k,j,i) - ug(k) )
           ENDDO
        ENDDO
@@ -1616,15 +1356,6 @@
     CALL cpu_log( log_point(6), 'v-equation', 'start' )
 
-!
-!-- v-tendency terms with communication
-    IF ( momentum_advec == 'ups-scheme' )  THEN
-       tend = 0.0
-       CALL advec_v_ups
-    ENDIF
-
-!
-!-- v-tendency terms with no communication
-    IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-       tend = 0.0
+    tend = 0.0
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_mom )  THEN
           CALL advec_v_ws
@@ -1633,15 +1364,7 @@
        END IF
     ELSE
-       IF ( momentum_advec /= 'ups-scheme' )  THEN
-          tend = 0.0
-          CALL advec_v_up
-       ENDIF
+       CALL advec_v_up
     ENDIF
-    IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-       CALL diffusion_v( ddzu, ddzw, km_m, tend, u_m, v_m, vsws_m, vswst_m, &
-                         w_m )
-    ELSE
-       CALL diffusion_v( ddzu, ddzw, km, tend, u, v, vsws, vswst, w )
-    ENDIF
+    CALL diffusion_v
     CALL coriolis( 2 )
 
@@ -1669,9 +1392,7 @@
        DO  j = nysv, nyn
           DO  k = nzb_v_inner(j,i)+1, nzt
-             v_p(k,j,i) = ( 1.0-tsc(1) ) * v_m(k,j,i) + tsc(1) * v(k,j,i) +    &
-                          dt_3d * (                                            &
-                                   tsc(2) * tend(k,j,i) + tsc(3) * tv_m(k,j,i) &
-                                  ) -                                          &
-                          tsc(5) * rdf(k) * ( v(k,j,i) - vg(k) )
+             v_p(k,j,i) = v(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
+                                               tsc(3) * tv_m(k,j,i) )          &
+                                   - tsc(5) * rdf(k) * ( v(k,j,i) - vg(k) )
           ENDDO
        ENDDO
@@ -1707,15 +1428,6 @@
     CALL cpu_log( log_point(7), 'w-equation', 'start' )
 
-!
-!-- w-tendency terms with communication
-    IF ( momentum_advec == 'ups-scheme' )  THEN
-       tend = 0.0
-       CALL advec_w_ups
-    ENDIF
-
-!
-!-- w-tendency terms with no communication
-    IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-       tend = 0.0
+    tend = 0.0
+    IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_mom )  THEN
           CALL advec_w_ws
@@ -1724,14 +1436,7 @@
        ENDIF
     ELSE
-       IF ( momentum_advec /= 'ups-scheme' )  THEN
-          tend = 0.0
-          CALL advec_w_up
-       ENDIF
+       CALL advec_w_up
     ENDIF
-    IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-       CALL diffusion_w( ddzu, ddzw, km_m, tend, u_m, v_m, w_m )
-    ELSE
-       CALL diffusion_w( ddzu, ddzw, km, tend, u, v, w )
-    ENDIF
+    CALL diffusion_w
     CALL coriolis( 3 )
 
@@ -1759,9 +1464,7 @@
        DO  j = nys, nyn
           DO  k = nzb_w_inner(j,i)+1, nzt-1
-             w_p(k,j,i) = ( 1-tsc(1) ) * w_m(k,j,i) + tsc(1) * w(k,j,i) +      &
-                          dt_3d * (                                            &
-                                   tsc(2) * tend(k,j,i) + tsc(3) * tw_m(k,j,i) &
-                                  ) -                                          &
-                          tsc(5) * rdf(k) * w(k,j,i)
+             w_p(k,j,i) = w(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
+                                               tsc(3) * tw_m(k,j,i) )          &
+                                   - tsc(5) * rdf(k) * w(k,j,i)
           ENDDO
        ENDDO
@@ -1802,5 +1505,4 @@
 !
 !--    pt-tendency terms with communication
-       sat = tsc(1)
        sbt = tsc(2)
        IF ( scalar_advec == 'bc-scheme' )  THEN
@@ -1808,26 +1510,17 @@
           IF ( timestep_scheme(1:5) /= 'runge' )  THEN
 !
-!--          Bott-Chlond scheme always uses Euler time step when leapfrog is
-!--          switched on. Thus:
-             sat = 1.0
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
              sbt = 1.0
           ENDIF
           tend = 0.0
           CALL advec_s_bc( pt, 'pt' )
-       ELSE
-          IF ( tsc(2) /= 2.0  .AND.  scalar_advec == 'ups-scheme' )  THEN
-             tend = 0.0
-             CALL advec_s_ups( pt, 'pt' )
-          ENDIF
+
        ENDIF
 
 !
 !--    pt-tendency terms with no communication
-       IF ( scalar_advec == 'bc-scheme' )  THEN
-          CALL diffusion_s( ddzu, ddzw, kh, pt, shf, tswst, wall_heatflux, &
-                            tend )
-       ELSE
-          IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-             tend = 0.0
+       IF ( scalar_advec /= 'bc-scheme' )  THEN
+          tend = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
                 CALL advec_s_ws( pt, 'pt' )
@@ -1836,17 +1529,9 @@
              ENDIF
           ELSE
-             IF ( scalar_advec /= 'ups-scheme' )  THEN
-                tend = 0.0
-                CALL advec_s_up( pt )
-             ENDIF
-          ENDIF
-          IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             CALL diffusion_s( ddzu, ddzw, kh_m, pt_m, shf_m, tswst_m, &
-                               wall_heatflux, tend )
-          ELSE
-             CALL diffusion_s( ddzu, ddzw, kh, pt, shf, tswst, wall_heatflux, &
-                               tend )
-          ENDIF
-       ENDIF
+             CALL advec_s_up( pt )
+          ENDIF
+       ENDIF
+
+       CALL diffusion_s( pt, shf, tswst, wall_heatflux )
 
 !
@@ -1881,10 +1566,8 @@
           DO  j = nys, nyn
              DO  k = nzb_s_inner(j,i)+1, nzt
-                pt_p(k,j,i) = ( 1 - sat ) * pt_m(k,j,i) + sat * pt(k,j,i) +    &
-                              dt_3d * (                                        &
-                                       sbt * tend(k,j,i) + tsc(3) * tpt_m(k,j,i)&
-                                      ) - &
-                              tsc(5) * ( pt(k,j,i) - pt_init(k) ) * &
-                              ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )  
+                pt_p(k,j,i) = pt(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +        &
+                                                    tsc(3) * tpt_m(k,j,i) )    &
+                                        - tsc(5) * ( pt(k,j,i) - pt_init(k) ) *&
+                                          ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )
              ENDDO
           ENDDO
@@ -1927,5 +1610,4 @@
 !
 !--    sa-tendency terms with communication
-       sat = tsc(1)
        sbt = tsc(2)
        IF ( scalar_advec == 'bc-scheme' )  THEN
@@ -1933,28 +1615,17 @@
           IF ( timestep_scheme(1:5) /= 'runge' )  THEN
 !
-!--          Bott-Chlond scheme always uses Euler time step when leapfrog is
-!--          switched on. Thus:
-             sat = 1.0
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
              sbt = 1.0
           ENDIF
           tend = 0.0
           CALL advec_s_bc( sa, 'sa' )
-       ELSE
-          IF ( tsc(2) /= 2.0 )  THEN
-             IF ( scalar_advec == 'ups-scheme' )  THEN
-                tend = 0.0
-                CALL advec_s_ups( sa, 'sa' )
-             ENDIF
-          ENDIF
+
        ENDIF
 
 !
 !--    sa-tendency terms with no communication
-       IF ( scalar_advec == 'bc-scheme' )  THEN
-          CALL diffusion_s( ddzu, ddzw, kh, sa, saswsb, saswst, &
-                            wall_salinityflux, tend )
-       ELSE
-          IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-             tend = 0.0
+       IF ( scalar_advec /= 'bc-scheme' )  THEN
+          tend = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
                  CALL advec_s_ws( sa, 'sa' )
@@ -1963,12 +1634,9 @@
              ENDIF
           ELSE
-             IF ( scalar_advec /= 'ups-scheme' )  THEN
-                tend = 0.0
-                CALL advec_s_up( sa )
-             ENDIF
-          ENDIF
-          CALL diffusion_s( ddzu, ddzw, kh, sa, saswsb, saswst, &
-                            wall_salinityflux, tend )
-       ENDIF
+             CALL advec_s_up( sa )
+          ENDIF
+       ENDIF
+
+       CALL diffusion_s( sa, saswsb, saswst, wall_salinityflux )
        
        CALL user_actions( 'sa-tendency' )
@@ -1979,9 +1647,8 @@
           DO  j = nys, nyn
              DO  k = nzb_s_inner(j,i)+1, nzt
-                sa_p(k,j,i) = sat * sa(k,j,i) +                                &
-                              dt_3d * (                                        &
-                                     sbt * tend(k,j,i) + tsc(3) * tsa_m(k,j,i) &
-                                      ) -                                      &
-                              tsc(5) * rdf_sc(k) * ( sa(k,j,i) - sa_init(k) )
+                sa_p(k,j,i) = sa(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +        &
+                                                    tsc(3) * tsa_m(k,j,i) )    &
+                                        - tsc(5) * rdf_sc(k) *                 &
+                                          ( sa(k,j,i) - sa_init(k) )
                 IF ( sa_p(k,j,i) < 0.0 )  sa_p(k,j,i) = 0.1 * sa(k,j,i)
              ENDDO
@@ -2031,5 +1698,4 @@
 !
 !--    Scalar/q-tendency terms with communication
-       sat = tsc(1)
        sbt = tsc(2)
        IF ( scalar_advec == 'bc-scheme' )  THEN
@@ -2037,27 +1703,17 @@
           IF ( timestep_scheme(1:5) /= 'runge' )  THEN
 !
-!--          Bott-Chlond scheme always uses Euler time step when leapfrog is
-!--          switched on. Thus:
-             sat = 1.0
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
              sbt = 1.0
           ENDIF
           tend = 0.0
           CALL advec_s_bc( q, 'q' )
-       ELSE
-          IF ( tsc(2) /= 2.0 )  THEN
-             IF ( scalar_advec == 'ups-scheme' )  THEN
-                tend = 0.0
-                CALL advec_s_ups( q, 'q' )
-             ENDIF
-          ENDIF
+
        ENDIF
 
 !
 !--    Scalar/q-tendency terms with no communication
-       IF ( scalar_advec == 'bc-scheme' )  THEN
-          CALL diffusion_s( ddzu, ddzw, kh, q, qsws, qswst, wall_qflux, tend )
-       ELSE
-          IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-             tend = 0.0
+       IF ( scalar_advec /= 'bc-scheme' )  THEN
+          tend = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
                 CALL advec_s_ws( q, 'q' )
@@ -2066,17 +1722,9 @@
              ENDIF
           ELSE
-             IF ( scalar_advec /= 'ups-scheme' )  THEN
-                tend = 0.0
-                CALL advec_s_up( q )
-             ENDIF
-          ENDIF
-          IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             CALL diffusion_s( ddzu, ddzw, kh_m, q_m, qsws_m, qswst_m, &
-                               wall_qflux, tend )
-          ELSE
-             CALL diffusion_s( ddzu, ddzw, kh, q, qsws, qswst, &
-                               wall_qflux, tend )
-          ENDIF
-       ENDIF
+             CALL advec_s_up( q )
+          ENDIF
+       ENDIF
+
+       CALL diffusion_s( q, qsws, qswst, wall_qflux )
        
 !
@@ -2104,9 +1752,8 @@
           DO  j = nys, nyn
              DO  k = nzb_s_inner(j,i)+1, nzt
-                q_p(k,j,i) = ( 1 - sat ) * q_m(k,j,i) + sat * q(k,j,i) +       &
-                             dt_3d * (                                         &
-                                      sbt * tend(k,j,i) + tsc(3) * tq_m(k,j,i) &
-                                     ) -                                       &
-                             tsc(5) * rdf_sc(k) * ( q(k,j,i) - q_init(k) )
+                q_p(k,j,i) = q(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
+                                                  tsc(3) * tq_m(k,j,i) )       &
+                                      - tsc(5) * rdf_sc(k) *                   &
+                                        ( q(k,j,i) - q_init(k) )
                 IF ( q_p(k,j,i) < 0.0 )  q_p(k,j,i) = 0.1 * q(k,j,i)
              ENDDO
@@ -2152,5 +1799,4 @@
        CALL production_e_init
 
-       sat = tsc(1)
        sbt = tsc(2)
        IF ( .NOT. use_upstream_for_tke )  THEN
@@ -2159,18 +1805,10 @@
              IF ( timestep_scheme(1:5) /= 'runge' )  THEN
 !
-!--             Bott-Chlond scheme always uses Euler time step when leapfrog is
-!--             switched on. Thus:
-                sat = 1.0
+!--             Bott-Chlond scheme always uses Euler time step. Thus:
                 sbt = 1.0
              ENDIF
              tend = 0.0
              CALL advec_s_bc( e, 'e' )
-          ELSE
-             IF ( tsc(2) /= 2.0 )  THEN
-                IF ( scalar_advec == 'ups-scheme' )  THEN
-                   tend = 0.0
-                   CALL advec_s_ups( e, 'e' )
-                ENDIF
-             ENDIF
+
           ENDIF
        ENDIF
@@ -2178,25 +1816,11 @@
 !
 !--    TKE-tendency terms with no communication
-       IF ( scalar_advec == 'bc-scheme'  .AND.  .NOT. use_upstream_for_tke )  &
-       THEN
-          IF ( .NOT. humidity )  THEN
-             IF ( ocean )  THEN
-                CALL diffusion_e( ddzu, dd2zu, ddzw, diss, e, km, l_grid, &
-                                  prho, prho_reference, rif, tend, zu, zw )
-             ELSE
-                CALL diffusion_e( ddzu, dd2zu, ddzw, diss, e, km, l_grid, pt, &
-                                  pt_reference, rif, tend, zu, zw )
-             ENDIF
-          ELSE
-             CALL diffusion_e( ddzu, dd2zu, ddzw, diss, e, km, l_grid, vpt, &
-                               pt_reference, rif, tend, zu, zw )
-          ENDIF
-       ELSE
+       IF ( scalar_advec /= 'bc-scheme'  .OR.  use_upstream_for_tke )  THEN
           IF ( use_upstream_for_tke )  THEN
              tend = 0.0
              CALL advec_s_up( e )
           ELSE
-             IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-                tend = 0.0
+             tend = 0.0
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_sca )  THEN
                    CALL advec_s_ws( e, 'e' )
@@ -2205,33 +1829,19 @@
                 ENDIF
              ELSE
-                IF ( scalar_advec /= 'ups-scheme' )  THEN
-                   tend = 0.0
-                   CALL advec_s_up( e )
-                ENDIF
-             ENDIF
-          ENDIF
-          IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             IF ( .NOT. humidity )  THEN
-                CALL diffusion_e( ddzu, dd2zu, ddzw, diss, e_m, km_m, l_grid, &
-                                  pt_m, pt_reference, rif_m, tend, zu, zw )
-             ELSE
-                CALL diffusion_e( ddzu, dd2zu, ddzw, diss, e_m, km_m, l_grid, &
-                                  vpt_m, pt_reference, rif_m, tend, zu, zw )
-             ENDIF
+                CALL advec_s_up( e )
+             ENDIF
+          ENDIF
+       ENDIF
+
+       IF ( .NOT. humidity )  THEN
+          IF ( ocean )  THEN
+             CALL diffusion_e( prho, prho_reference )
           ELSE
-             IF ( .NOT. humidity )  THEN
-                IF ( ocean )  THEN
-                   CALL diffusion_e( ddzu, dd2zu, ddzw, diss, e, km, l_grid, &
-                                     prho, prho_reference, rif, tend, zu, zw )
-                ELSE
-                   CALL diffusion_e( ddzu, dd2zu, ddzw, diss, e, km, l_grid, &
-                                     pt, pt_reference, rif, tend, zu, zw )
-                ENDIF
-             ELSE
-                CALL diffusion_e( ddzu, dd2zu, ddzw, diss, e, km, l_grid, vpt, &
-                                  pt_reference, rif, tend, zu, zw )
-             ENDIF
-          ENDIF
-       ENDIF
+             CALL diffusion_e( pt, pt_reference )
+          ENDIF
+       ELSE
+          CALL diffusion_e( vpt, pt_reference )
+       ENDIF
+
        CALL production_e
 
@@ -2249,8 +1859,6 @@
           DO  j = nys, nyn
              DO  k = nzb_s_inner(j,i)+1, nzt
-                e_p(k,j,i) = ( 1 - sat ) * e_m(k,j,i) + sat * e(k,j,i) +       &
-                             dt_3d * (                                         &
-                                      sbt * tend(k,j,i) + tsc(3) * te_m(k,j,i) &
-                                     )
+                e_p(k,j,i) = e(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
+                                                  tsc(3) * te_m(k,j,i) )
                 IF ( e_p(k,j,i) < 0.0 )  e_p(k,j,i) = 0.1 * e(k,j,i)
              ENDDO
